W        =     6
I        =     7
J        =     8
K        =     9
A1L      =     $3C
A1H      =     $3D
K40      =     $FC
I40      =     $FD
IWL      =     $FE
IWH      =     $FF
KBD      =     $C000
KBDSTRB  =     $C010
LORES    =     $C056
AN3OFF   =     $C05F
PLOT     =     $F800
SETCOL   =     $F864
SETGR    =     $FB40
HOME     =     $FC58
         ORG   $2000
         JSR   SETGR      ;GR
         LDA   LORES
         LDA   AN3OFF
         JSR   HOME       ;HOME
         LDA   #3         ;FOR W=3 TO 50
         STA   W
WLP      LDA   #0         ;IW=0
         STA   IWL
         STA   IWH
         LDA   #40        ;I40=40
         STA   I40
         LDA   #1         ;FOR I=1 TO 19
         STA   I
ILP      LDA   W          ;IW=IW+W
         CLC
         ADC   IWL
         STA   IWL
         BCC   ILP1
         INC   IWH
ILP1     STA   A1L        ;X=IW/12
         LDA   IWH
         STA   A1H
         LDY   #16        ;(inline 16/8 division)
         LDA   #0
DIV1LP   ASL   A1L
         ROL   A1H
         ROL
         CMP   #12
         BCC   DIV1A
         SBC   #12
         INC   A1L
DIV1A    DEY
         BNE   DIV1LP
         LDX   A1L
         DEC   I40        ;I40=I40-1
         LDA   I40        ;K40=I40
         STA   K40
         LDA   #0         ;FOR J=0 TO 19
         STA   J
JLP      CLC              ;K=I+J
         ADC   I
         STA   K
         LDA   KBD        ;IF PEEK(KBD)>127 THEN DONE
         BPL   NOKEY
         STA   KBDSTRB
         JMP   DONE
NOKEY    LDA   J          ;COLOR=J*3/(I+3)+X
         ASL
         ADC   J
         STA   A1L
         LDA   I
         ADC   #3
         STA   A1H
         LDA   #0         ;(inline 8/8 division)
         LDY   #8
DIV2LP   ASL   A1L
         ROL
         CMP   A1H
         BCC   DIV2A
         SBC   A1H
         INC   A1L
DIV2A    DEY
         BNE   DIV2LP
         TXA
         CLC
         ADC   A1L
         JSR   SETCOL
         LDY   I          ;PLOT I,K: etc...
         LDA   K
         JSR   PLOT
         LDY   K
         LDA   I
         JSR   PLOT
         LDY   I40
         LDA   K40
         JSR   PLOT
         LDY   K40
         LDA   I40
         JSR   PLOT
         LDY   K
         LDA   I40
         JSR   PLOT
         LDY   I40
         LDA   K
         JSR   PLOT
         LDY   I
         LDA   K40
         JSR   PLOT
         LDY   K40
         LDA   I
         JSR   PLOT
         DEC   K40        ;K40=K40-1
         INC   J          ;NEXT J
         LDA   J
         CMP   #20
         BNE   JLP
         INC   I          ;NEXT I
         LDA   I
         CMP   #20
         BEQ   NOILP
         JMP   ILP
NOILP    INC   W          ;NEXT W
         LDA   W
         CMP   #51
         BEQ   DONE
         JMP   WLP
DONE     RTS
